## freecell-solver 3.12.0

=== CMakeLists.txt ===
INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/Common.cmake" )

LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

# This is the equivalent to perform a "make dist"/"make distdir" etc.
SET(CPACK_PACKAGE_NAME "freecell-solver")
SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Freecell Solver")
SET(CPACK_PACKAGE_VENDOR "Shlomi Fish")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.txt")

# Process and extract the version number.
FILE( READ "ver.txt" VERSION)

CHOMP (VERSION)

STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")

LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
LIST(GET VERSION_DIGITS 2 CPACK_PACKAGE_VERSION_PATCH)

SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET(CPACK_SOURCE_PACKAGE_FILE_NAME "${CPACK_PACKAGE_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")

SET (base_with_ver "freecell-solver-[0-9]+\\\\.[0-9]+\\\\.[0-9]+")

SET(CPACK_SOURCE_IGNORE_FILES
    "/_CPack_Packages/"
    "/CMakeFiles/"
    "/.deps/"
    "^${base_with_ver}(-Source|-Linux)?/"
    "${base_with_ver}.tar\\\\.(gz|bz2|Z|lzma|xz)$"
    "\\\\.o$"
    "~$"
    "/board_gen/(pi-make-microsoft-freecell-board|make-microsoft-freecell-board|make-gnome-freecell-board|make-aisleriot-freecell-board)$"
    "/(dbm_fc_solver|fcc_fc_solver|fc-solve|fc-solve-pruner|freecell-solver-range-parallel-solve|freecell-solver-fc-pro-range-solve|freecell-solver-multi-thread-solve|freecell-solver-fork-solve|measure-depth-dep-tests-order-perf)$"
    "/lib(fcs|freecell-solver)\\\\.(a|la)$"
    "\\\\.so(\\\\.[0-9]+)*$"
    "/\\\\.svn/"
    "\\\\.(pdf|fo)$"
    "/t/t/.*\\\\.exe$"
    "/t/Presets"
    "/CMakeCache\\\\.txt$"
    "/Makefile$"
    "/CTestTestfile\\\\.cmake$"
    "/cmake_install\\\\.cmake$"
    "/CPackConfig\\\\.cmake$"
    "/CPackSourceConfig\\\\.cmake$"
    "/tags$"
    "/freecell-solver-config$"
    "/libfreecell-solver\\\\.pc$"
    "/([0-9]+)\\\\.board$"
    "/config\\\\.h$"
    "/install_manifest\\\\.txt$"
    "/t/card-test-(parse|render)\\\\.c$"
    "/Testing/"
    "ids-whitelist\\\\.txt"
    "/_Inline/"
    "/(build|BUILD)/"
)

IF(WIN32 AND NOT UNIX)
    # There is a bug in NSI that does not handle full unix paths properly. Make
    # sure there is at least one set of four (4) backlasshes.
    SET(CPACK_PACKAGE_ICON "${CMAKE_SOURCE_DIR}\\\\dondorf-king.bmp")
    SET(CPACK_NSIS_INSTALLED_ICON_NAME "bin\\\\fc-solve.exe")
    SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\fc-solve.shlomifish.org")
    SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\fc-solve.shlomifish.org")
    SET(CPACK_NSIS_DISPLAY_NAME "Freecell Solver")
    SET(CPACK_NSIS_CONTACT "shlomif@iglu.org.il")
    SET(CPACK_NSIS_MODIFY_PATH ON)
    # Setting for NSIS :
    SET(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\fc-solve.ico")
    SET(CPACK_NSIS_MUI_UNIICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_PACKAGE_ICON ${CPACK_NSIS_MUI_ICON})
    SET(CPACK_NSIS_MODIFY_PATH "ON")
ELSE(WIN32 AND NOT UNIX)
  SET(CPACK_STRIP_FILES "fc-solve")
  SET(CPACK_SOURCE_STRIP_FILES "")
ENDIF(WIN32 AND NOT UNIX)

SET(CPACK_PACKAGE_EXECUTABLES
    "fc-solve" "Single-Game Solver"
)

### This is to set the RPATH correctly, so when installed under a prefix
### the executables will find the libraries.
###
### See:
###
### http://www.cmake.org/Wiki/CMake_RPATH_handling
###
### (Taken from that wiki page)

# use, i.e. don't skip the full RPATH for the build tree
SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)

# the RPATH to be used when installing
SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib${LIB_SUFFIX}")

# add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

SET (STATES_TYPE "INDIRECT_STACK_STATES" CACHE STRING
    "States Type ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES'). No need to usually change.")
SET (FCS_ENABLE_RCS_STATES CACHE BOOL "Whether to use RCS-like states (requires a STATES_TYPE of COMPACT_STATES")
SET (FCS_ENABLE_DBM_SOLVER CACHE BOOL "Whether to build the DBM solver")
SET (FCS_DBM_BACKEND "bdb" CACHE STRING "Type of DBM backend.")
SET (FCS_DBM_TREE_BACKEND "libavl2" CACHE STRING "Type of DBM tree backend.")
SET (IA_STATE_PACKS_GROW_BY 32 CACHE STRING "Amount to Grow State Packs By")
SET (FCS_IA_PACK_SIZE 64 CACHE STRING "Size of a single pack in kilo-bytes.")
SET (MAX_NUM_FREECELLS 8 CACHE STRING "Maximal Number of Freecells")
SET (MAX_NUM_STACKS 10 CACHE STRING "Maximal Number of Stacks")
SET (MAX_NUM_INITIAL_CARDS_IN_A_STACK 8 CACHE STRING
    "Maximal Number of Initial Cards in a Stack")
SET (MAX_NUM_DECKS 2 CACHE STRING "Maximal Number of Decks (1 or 2)")
SET (MAX_NUM_BENCHMARK_THREADS 4 CACHE STRING "Maximal Number of Threads to Use When Benchmarking")

SET (FCS_STATE_STORAGE "FCS_STATE_STORAGE_INTERNAL_HASH" CACHE STRING "The State Storage Type")
SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_INTERNAL_HASH" CACHE STRING "The Stack Storage Type")
SET (FCS_RCS_CACHE_STORAGE "FCS_RCS_CACHE_STORAGE_KAZ_TREE" CACHE STRING "The LRU Cache Type of for FCS_RCS_STATES.")

SET (FCS_WHICH_COLUMNS_GOOGLE_HASH "FCS_WHICH_COLUMNS_GOOGLE_HASH__SPARSE" CACHE STRING "The Columns' Google Hash Type")
SET (FCS_WHICH_STATES_GOOGLE_HASH "FCS_WHICH_STATES_GOOGLE_HASH__SPARSE" CACHE STRING "The States/Positions' Google Hash Type")

SET (FCS_FREECELL_ONLY "" CACHE BOOL "Configure Freecell Solver to only be able to solve Freecell (not recommended)")
SET (FCS_DISABLE_SIMPLE_SIMON "" CACHE BOOL "Exclude being able to solve Simple Simon from the Binary (not recommended)")
SET (FCS_WITHOUT_CARD_FLIPPING "1" CACHE BOOL "Exclude the flipping of cards from the binary.")
SET (FCS_WITH_TEST_SUITE "" CACHE BOOL "Also build and run the test suite.")
SET (FCS_LINK_TO_STATIC "" CACHE BOOL "Link to the static library.")
SET (FCS_HARD_CODED_NUM_FCS_FOR_FREECELL_ONLY "4" CACHE STRING "The hard-coded number of freecells (4, 2, etc.). Usually ignored")

SET (FCS_ENABLE_SECONDARY_HASH_VALUE ""
    CACHE BOOL
    "Enable the secondary hash value calculation and track-keeping. Seems to slow things down."
)

SET (FCS_WITH_CONTEXT_VARIABLE "1"
    CACHE BOOL
    "Enable the context (extra void *) as passed to the comparison functions, etc."
)

SET (FCS_INLINED_HASH_COMPARISON "1"
    CACHE BOOL
    "Use more compact tokens for moves internally (makes things slower)"
)

SET (FCS_AVOID_TCMALLOC ""
    CACHE BOOL
    "Avoid linking against Google's tcmalloc"
)

SET (FCS_BUILD_DOCS "1" CACHE BOOL "Whether to build the documentation or not.")

SET (BUILD_STATIC_LIBRARY "1" CACHE BOOL "Whether to build the static library (which takes more time)" )

SET (CPU_ARCH "" CACHE STRING "A specific CPU architecture to pass to gcc")
SET (OPTIMIZATION_OMIT_FRAME_POINTER "" CACHE STRING "Use -fomit-frame-pointer with gcc (not recommended for debugging)")

SET (FCS_STATE_STORAGE_LIBAVL2_TREE_TYPE "avl" CACHE STRING "The libavl2 tree type used for the state storage. Ignored if not set to libavl2")
SET (FCS_STACK_STORAGE_LIBAVL2_TREE_TYPE "avl" CACHE STRING "The libavl2 tree type used for the stack storage. Ignored if not set to libavl2")
SET (LIBAVL2_SOURCE_DIR "/usr/src/avl-2.0.3" CACHE STRING "The location of the libavl2 source tree (from which files are copied)")

SET (LEVELDB_SOURCE_DIR "/home/shlomif/Download/unpack/prog/leveldb/leveldb" CACHE STRING "The location of the LevelDB sources.")

SET (FCS_WITHOUT_VISITED_ITER "" CACHE BOOL "Disable the visited_iter counter in each state (somewhat useful for debugging, otherwise not needed.)")
SET (FCS_WITHOUT_DEPTH_FIELD "" CACHE BOOL "Disable the depth field in each state (not absolutely necessary.)")
SET (FCS_WITHOUT_LOCS_FIELDS "" CACHE BOOL "Does not do anything (kept for backwards-compatibility)")
SET (FCS_TRACE_MEM "" CACHE BOOL "Enable memory tracing in fc-solve.")
SET (FCS_MAX_NUM_SCANS_BUCKETS "" CACHE STRING "The number of scan_visited buckets in fc-solve (safe to ignore).")

IF (NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))
    MESSAGE(FATAL_ERROR "STATES_TYPE should be ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES')")
ENDIF(NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES|DEBUG_STATES)$"))

SET (${STATES_TYPE} 1)

IF (FCS_ENABLE_RCS_STATES)
    SET (FCS_RCS_STATES 1)
ENDIF (FCS_ENABLE_RCS_STATES)

SET (FREECELL_SOLVER_LIB_MODULES alloc.c app_str.c card.c check_and_add_state.c cmd_line.c freecell.c instance.c lib.c move.c move_funcs_maps.c move_funcs_order.c preset.c scans.c simpsim.c split_cmd_line.c state.c)

IF (FCS_FREECELL_ONLY)
    LIST (REMOVE_ITEM FREECELL_SOLVER_LIB_MODULES preset.c)
    SET (FCS_DISABLE_SIMPLE_SIMON 1)
ENDIF (FCS_FREECELL_ONLY)

IF (FCS_DISABLE_SIMPLE_SIMON)
    LIST (REMOVE_ITEM FREECELL_SOLVER_LIB_MODULES simpsim.c)
ENDIF (FCS_DISABLE_SIMPLE_SIMON)

IF (NOT (${STATES_TYPE} STREQUAL "INDIRECT_STACK_STATES"))
    # FCS_STACK_STORAGE in this case is irrelevant and should be ignored.
    SET (FCS_STACK_STORAGE "FCS_STACK_STORAGE_NULL")
ENDIF (NOT (${STATES_TYPE} STREQUAL "INDIRECT_STACK_STATES"))

# Add the fcs_hash.c module if (and only if) it is being used.
#
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))

    LIST(APPEND FREECELL_SOLVER_LIB_MODULES fcs_hash.c)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INTERNAL_HASH") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_INTERNAL_HASH"))

# Add the kaz_tree.c module if (and only if) it is being used.
#
IF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_KAZ_TREE" OR
    (FCS_RCS_STATES AND (${FCS_RCS_CACHE_STORAGE} STREQUAL "FCS_RCS_CACHE_STORAGE_KAZ_TREE")))

    LIST(APPEND FREECELL_SOLVER_LIB_MODULES kaz_tree.c)

ENDIF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_KAZ_TREE" OR
    (FCS_RCS_STATES AND (${FCS_RCS_CACHE_STORAGE} STREQUAL "FCS_RCS_CACHE_STORAGE_KAZ_TREE")))


# Add the google_hash.cpp if (and only if) it is being used.
#
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_GOOGLE_DENSE_HASH") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_GOOGLE_DENSE_HASH"))

    LIST(APPEND FREECELL_SOLVER_LIB_MODULES google_hash.cpp)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_GOOGLE_DENSE_HASH") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_GOOGLE_DENSE_HASH"))

# Add fcs_dm.c if (and only if) it is being used.
#
IF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")
    LIST(APPEND FREECELL_SOLVER_LIB_MODULES fcs_dm.c)
ENDIF (${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_INDIRECT")

# Search for libredblack if appropriate.
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))

    FIND_LIBRARY(LIBREDBLACK_LIB redblack)

ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))

# Search for Judy ( http://judy.sourceforge.net/ ) if appropriate.
IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
    (FCS_RCS_STATES AND (${FCS_RCS_CACHE_STORAGE} STREQUAL "FCS_RCS_CACHE_STORAGE_JUDY")
    )
)

    FIND_LIBRARY(LIBJUDY_LIB Judy)
ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
    (FCS_RCS_STATES AND (${FCS_RCS_CACHE_STORAGE} STREQUAL "FCS_RCS_CACHE_STORAGE_JUDY")
    )
)

=== board_gen/CMakeLists.txt ===
INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/../Common.cmake" )

ADD_EXECUTABLE (
    make-gnome-freecell-board
    make_gnome_freecell_board.c
)

ADD_EXECUTABLE(
    make-aisleriot-freecell-board
    make_aisleriot_freecell_board.c
)

ADD_EXECUTABLE(
    make-microsoft-freecell-board
    make_microsoft_freecell_board.c
)

ADD_EXECUTABLE(
    pi-make-microsoft-freecell-board
    pi_make_microsoft_freecell_board.c
)

SET (make_pysol "make_pysol_freecell_board.py")
SET (_dest "${CMAKE_CURRENT_BINARY_DIR}/${make_pysol}")
SET (_src  "${CMAKE_CURRENT_SOURCE_DIR}/${make_pysol}")

# Adapted from:
# http://stackoverflow.com/questions/697560/how-to-copy-directory-from-source-tree-to-binary-tree
ADD_CUSTOM_COMMAND(
    OUTPUT "${_dest}"
    DEPENDS "${_src}"
    COMMAND "${CMAKE_COMMAND}" "-E" "copy" "${_src}" "${_dest}"
)

ADD_CUSTOM_TARGET(
    "${make_pysol}"
    ALL DEPENDS "${_dest}"
)

SET (_make_py_dest "${_dest}")

RUN_POD2MAN(
    "${CMAKE_CURRENT_SOURCE_DIR}/fc-solve-board_gen.pod"
    "fc-solve-board_gen.6"
    "6"
    "board_gen"
    "board_gen ${VERSION}"
)

INSTALL_MAN("${CMAKE_CURRENT_BINARY_DIR}/fc-solve-board_gen.6" 6)

# Install the nroff symbolic links.
INSTALL_MAN ("make-aisleriot-freecell-board.6" 6)
INSTALL_MAN ("make-gnome-freecell-board.6" 6)
INSTALL_MAN ("make_pysol_freecell_board.py.6" 6)
INSTALL_MAN ("pi-make-microsoft-freecell-board.6" 6)

INSTALL(
    TARGETS
        "make-gnome-freecell-board"
        "pi-make-microsoft-freecell-board"
        "make-aisleriot-freecell-board"
        "make-microsoft-freecell-board"
    DESTINATION
        "bin"
)

INSTALL(
    PROGRAMS
        "${_make_py_dest}"
    DESTINATION
        "bin"
)

=== t/CMakeLists.txt ===
INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/../Common.cmake" )

MACRO(MY_ADD_EXE EXE_FILE C_FILE)
    SET (EXE_FILE_DEST "${CMAKE_CURRENT_SOURCE_DIR}/${EXE_FILE}")
    SET (C_FILE_SRC "${CMAKE_CURRENT_SOURCE_DIR}/${C_FILE}")

    ADD_EXECUTABLE(
        ${EXE_FILE}
        ${C_FILE}
    )

    TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB})

    SET_SOURCE_FILES_PROPERTIES (
        "${C_FILE}"
        PROPERTIES 
            OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../card.c"
            GENERATED "1"
    )

    ADD_CUSTOM_COMMAND(
        OUTPUT "${C_FILE}"
        COMMAND "perl" ARGS "${CMAKE_CURRENT_SOURCE_DIR}/generate-card-tests.pl"
        MAIN_DEPENDENCY "${CMAKE_CURRENT_SOURCE_DIR}/${C_FILE}.tt"
        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/generate-card-tests.pl"
    )

ENDMACRO(MY_ADD_EXE EXE_FILE C_FILE)

IF (FCS_WITH_TEST_SUITE)

    FIND_LIBRARY(LIBTAP_LIB tap)

    INCLUDE_DIRECTORIES (BEFORE "${CMAKE_BINARY_DIR}")

    MY_ADD_EXE (
        "t/card-test-render.exe"
        "card-test-render.c"
    )

    MY_ADD_EXE (
        "t/card-test-parse.exe"
        "card-test-parse.c"
    )

    ADD_EXECUTABLE(
        "out-split-cmd-line.exe"
        "${CMAKE_CURRENT_SOURCE_DIR}/out-split-cmd-line.c"
    )

    SET_SOURCE_FILES_PROPERTIES (
        "out-split-cmd-line.c"
        PROPERTIES 
            OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../split_cmd_line.c"
            GENERATED "1"
    )

    FILE (MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/t")

    SET (EXE_FILE "t/bit-reader-and-writer-test.exe")

    ADD_EXECUTABLE(
        "${EXE_FILE}"
        "${CMAKE_CURRENT_SOURCE_DIR}/bit-reader-and-writer-test.c"
    )

    TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB})

    SET_SOURCE_FILES_PROPERTIES (
        "bit-reader-and-writer-test.c"
        PROPERTIES 
            OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../bit_rw.h"
            GENERATED "1"
    )

    SET (EXE_FILE "t/delta-states-test.exe")

    ADD_EXECUTABLE(
        "${EXE_FILE}"
        "${CMAKE_CURRENT_SOURCE_DIR}/delta-states-test.c"
    )

    TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB})

    SET_SOURCE_FILES_PROPERTIES (
        "delta-states-test.c"
        PROPERTIES
            OBJECT_DEPENDS
                "${CMAKE_CURRENT_SOURCE_DIR}/../delta_states.c"
            GENERATED "1"
    )

    SET (EXE_FILE "t/dbm-kaztree-compare-records-test.exe")

    ADD_EXECUTABLE(
        "${EXE_FILE}"
        "dbm-kaztree-compare-records-test.c"
    )

    # This is a kind-of-temporary kludge to make 
    # "dbm-kaztree-compare-records-test.c" build.
    ADD_DEFINITIONS("-DFCS_DBM_USE_LIBAVL=1"
        "-I${CMAKE_CURRENT_SOURCE_DIR}/.."
        "-I${CMAKE_CURRENT_SOURCE_DIR}/../libavl/"
        )
    TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB})

ENDIF(FCS_WITH_TEST_SUITE)

=== Presets/presets/CMakeLists.txt ===
INSTALL(
    FILES
        "abra-kadabra.sh"
        "blue-yonder.sh"
        "children-playing-ball.sh"
        "cool-jives.sh"
        "crooked-nose.sh"
        "enlightened-ostrich.sh"
        "fools-gold.sh"
        "foss-nessy.sh"
        "gooey-unknown-thing.sh"
        "hello-world.sh"
        "john_galt_line-500.sh"
        "maliciously-obscure.sh"
        "rin-tin-tin.sh"
        "sand-stone.sh"
        "sentient-pearls.sh"
        "tea-for-two.sh"
        "the-iglu-cabal.sh"
        "three-eighty.sh"
        "toons-for-twenty-somethings.sh"
        "yellow-brick-road.sh"
    DESTINATION
        "${PKGDATADIR}/presets"
)

=== debian/changelog ===
freecell-solver (3.12.0-1) unstable; urgency=low

  * New upstream version. (closes: #675262)

 -- Gergely Risko <risko@debian.org>  Fri, 22 Jun 2012 10:08:05 +0200

freecell-solver (3.4.0-1) unstable; urgency=low

  * New upstream version (closes: #589387):
    - no more string exceptions (closes: #585191)

 -- Gergely Risko <risko@debian.org>  Mon, 10 Jan 2011 20:24:21 +0100

freecell-solver (2.34.0-1) unstable; urgency=low

  * New upstream version

 -- RISKO Gergely <risko@debian.org>  Wed, 15 Jul 2009 17:42:19 +0300

freecell-solver (2.20.0-1) unstable; urgency=low

  * Imported Upstream version 2.20.0
    - fixed new manpage cmake issues in the upstream sources
  * fixed the references in fc-solve-board_gen.pod and fc-solve.pod
  * fixed freecell-solver-config in the dev package
  * added watch file
  * added Vcs and Homepage fields to debian/control

 -- RISKO Gergely <risko@debian.org>  Fri, 27 Mar 2009 00:23:48 +0200

freecell-solver (2.16.0-1) unstable; urgency=low

  * Imported Upstream version 2.16.0 (closes: #518440)
  * cmake is the new buildsystem

 -- RISKO Gergely <risko@debian.org>  Sun, 15 Mar 2009 23:42:21 +0200

freecell-solver (2.8.10-1) unstable; urgency=low

  * New upstream release
  * fixed override disparity

 -- RISKO Gergely <risko@debian.org>  Wed, 30 Mar 2005 20:12:47 +0200

freecell-solver (2.8.9-1) unstable; urgency=low

  * New upstream release
    - it says now that microsoft #11982 is unsolvable (closes: #211869)
  * cdbsized things

 -- RISKO Gergely <risko@debian.org>  Wed, 30 Mar 2005 13:15:22 +0200

=== debian/control ===
Source: freecell-solver
Section: devel
Priority: optional
Maintainer: Gergely Risko <risko@debian.org>
Vcs-Browser: http://git.debian.org/?p=collab-maint/freecell-solver.git;a=summary
Vcs-Git: git://git.debian.org/collab-maint/freecell-solver.git
Build-depends: cmake (>= 2.6), dpkg-dev (>= 1.16.1~), cdbs (>= 0.4.85~),
 debhelper (>= 9~),
 dh-buildinfo
Homepage: http://fc-solve.berlios.de/
Standards-Version: 3.9.3.1

Package: libfreecell-solver0
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Library for solving Freecell games
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and
 static libraries necessary for developing programs using Freecell Solver.

Package: libfreecell-solver-dev
Architecture: any
Section: libdevel
Depends: libfreecell-solver0 (= ${binary:Version}), ${misc:Depends}
Description: Library for solving Freecell games (Development files)
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and
 static libraries necessary for developing programs using Freecell Solver.
 .
 This package contains the files necessary to produce binaries which are
 linked against libfreecell-solver.

Package: freecell-solver-bin
Architecture: any
Section: games
Depends: ${shlibs:Depends}, python, ${misc:Depends}
Description: Library for solving Freecell games
 Freecell Solver is a library for automatically solving boards of Freecell and
 similar variants of card Solitaire. This package contains the header files and
 static libraries necessary for developing programs using Freecell Solver.
 .
 This package contains the binaries included with freecell-solver

=== debian/rules ===
#!/usr/bin/make -f

DEB_AUTO_UPDATE_DEBIAN_CONTROL := true
DEB_CMAKE_EXTRA_FLAGS := -DDATADIR=/usr/share
DEB_CLEAN_EXCLUDE := config.h.orig

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/cdbs/1/class/cmake.mk
include /usr/share/cdbs/1/rules/debhelper.mk

binary-post-install/freecell-solver-bin::
	mv debian/freecell-solver-bin/usr/bin/pi-make-microsoft-freecell-board debian/freecell-solver-bin/usr/bin/make-microsoft-freecell-board
	mv debian/freecell-solver-bin/usr/share/man/man6/pi-make-microsoft-freecell-board.6 debian/freecell-solver-bin/usr/share/man/man6/make-microsoft-freecell-board.6
	mv debian/freecell-solver-bin/usr/bin/make_pysol_freecell_board.py debian/freecell-solver-bin/usr/bin/make-pysol-freecell-board
	mv debian/freecell-solver-bin/usr/share/man/man6/make_pysol_freecell_board.py.6 debian/freecell-solver-bin/usr/share/man/man6/make-pysol-freecell-board.6
	chmod a+x debian/freecell-solver-bin/usr/share/freecell-solver/presets/*
	mkdir -p debian/freecell-solver-bin/usr/share/lintian/overrides/
	cp debian/freecell-solver-bin.lintian debian/freecell-solver-bin/usr/share/lintian/overrides/freecell-solver-bin
	cp board_gen/README debian/freecell-solver-bin/usr/share/doc/freecell-solver-bin/README.board_gen

binary-post-install/libfreecell-solver-dev::
	mkdir -p debian/libfreecell-solver-dev/usr/share/lintian/overrides/
	cp debian/libfreecell-solver-dev.lintian debian/libfreecell-solver-dev/usr/share/lintian/overrides/libfreecell-solver-dev

## freecell-solver 3.20.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,14 @@
-INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/Common.cmake" )
-
-LIST(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")
+SET (private_mod_path "${CMAKE_SOURCE_DIR}/cmake")
+LIST (APPEND CMAKE_MODULE_PATH "${private_mod_path}")
+INCLUDE(Shlomif_Common)
+
+SHLOMIF_COMMON_SETUP("${private_mod_path}")
+
+SET (PKGDATADIR "${DATADIR}/freecell-solver")
+
+# Introduces VERSION , CPACK_PACKAGE_VERSION_MAJOR,
+# CPACK_PACKAGE_VERSION_MAJOR, and CPACK_PACKAGE_VERSION_PATCH
+READ_VERSION_FROM_VER_TXT()
 
 # This is the equivalent to perform a "make dist"/"make distdir" etc.
 SET(CPACK_PACKAGE_NAME "freecell-solver")
@@ -9,16 +17,6 @@
 SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.txt")
 SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING.txt")
 
-# Process and extract the version number.
-FILE( READ "ver.txt" VERSION)
-
-CHOMP (VERSION)
-
-STRING (REGEX MATCHALL "([0-9]+)" VERSION_DIGITS "${VERSION}")
-
-LIST(GET VERSION_DIGITS 0 CPACK_PACKAGE_VERSION_MAJOR)
-LIST(GET VERSION_DIGITS 1 CPACK_PACKAGE_VERSION_MINOR)
-LIST(GET VERSION_DIGITS 2 CPACK_PACKAGE_VERSION_PATCH)
 
 SET(CPACK_PACKAGE_INSTALL_DIRECTORY "${CPACK_PACKAGE_DESCRIPTION_SUMMARY} ${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
 
@@ -41,6 +39,7 @@
     "/\\\\.svn/"
     "\\\\.(pdf|fo)$"
     "/t/t/.*\\\\.exe$"
+    "\\\\.pyc$"
     "/t/Presets"
     "/CMakeCache\\\\.txt$"
     "/Makefile$"
@@ -58,7 +57,8 @@
     "/Testing/"
     "ids-whitelist\\\\.txt"
     "/_Inline/"
-    "/(build|BUILD)/"
+    "/(build|BUILD|B)/"
+    "/Presets/testing-presets"
 )
 
 IF(WIN32 AND NOT UNIX)
@@ -112,7 +112,7 @@
     "States Type ('INDIRECT_STACK_STATES', 'COMPACT_STATES' or 'DEBUG_STATES'). No need to usually change.")
 SET (FCS_ENABLE_RCS_STATES CACHE BOOL "Whether to use RCS-like states (requires a STATES_TYPE of COMPACT_STATES")
 SET (FCS_ENABLE_DBM_SOLVER CACHE BOOL "Whether to build the DBM solver")
-SET (FCS_DBM_BACKEND "bdb" CACHE STRING "Type of DBM backend.")
+SET (FCS_DBM_BACKEND "kaztree" CACHE STRING "Type of DBM backend.")
 SET (FCS_DBM_TREE_BACKEND "libavl2" CACHE STRING "Type of DBM tree backend.")
 SET (IA_STATE_PACKS_GROW_BY 32 CACHE STRING "Amount to Grow State Packs By")
 SET (FCS_IA_PACK_SIZE 64 CACHE STRING "Size of a single pack in kilo-bytes.")
@@ -133,7 +133,7 @@
 SET (FCS_FREECELL_ONLY "" CACHE BOOL "Configure Freecell Solver to only be able to solve Freecell (not recommended)")
 SET (FCS_DISABLE_SIMPLE_SIMON "" CACHE BOOL "Exclude being able to solve Simple Simon from the Binary (not recommended)")
 SET (FCS_WITHOUT_CARD_FLIPPING "1" CACHE BOOL "Exclude the flipping of cards from the binary.")
-SET (FCS_WITH_TEST_SUITE "" CACHE BOOL "Also build and run the test suite.")
+SET (FCS_WITH_TEST_SUITE "1" CACHE BOOL "Also build and run the test suite.")
 SET (FCS_LINK_TO_STATIC "" CACHE BOOL "Link to the static library.")
 SET (FCS_HARD_CODED_NUM_FCS_FOR_FREECELL_ONLY "4" CACHE STRING "The hard-coded number of freecells (4, 2, etc.). Usually ignored")
 
@@ -182,11 +182,47 @@
 
 SET (${STATES_TYPE} 1)
 
+IF (FCS_WITH_TEST_SUITE)
+    SET (FCS_ENABLE_DBM_SOLVER 1)
+ENDIF (FCS_WITH_TEST_SUITE)
+
 IF (FCS_ENABLE_RCS_STATES)
     SET (FCS_RCS_STATES 1)
 ENDIF (FCS_ENABLE_RCS_STATES)
 
-SET (FREECELL_SOLVER_LIB_MODULES alloc.c app_str.c card.c check_and_add_state.c cmd_line.c freecell.c instance.c lib.c move.c move_funcs_maps.c move_funcs_order.c preset.c scans.c simpsim.c split_cmd_line.c state.c)
+SET (rate_state_gen "${CMAKE_CURRENT_SOURCE_DIR}/gen_rate_state_c.pl")
+SET (rate_state_args "${rate_state_gen}" "${CMAKE_CURRENT_SOURCE_DIR}")
+# We do this so there will be no need to run "make" first.
+# See: http://github.com/kripken/emscripten/issues/766#issuecomment-11771150
+ADD_CUSTOM_COMMAND(
+    OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/rate_state.c"
+    COMMAND "perl"
+    ARGS ${rate_state_args}
+    DEPENDS "${rate_state_gen}" "${CMAKE_CURRENT_SOURCE_DIR}/rate_state.h"
+)
+
+EXECUTE_PROCESS(COMMAND "perl" ${rate_state_args})
+
+SET (FREECELL_SOLVER_LIB_MODULES
+    app_str.c
+    card.c
+    check_and_add_state.c
+    cmd_line.c
+    fc_pro_iface.c
+    freecell.c
+    instance.c
+    lib.c
+    meta_alloc.c
+    move.c
+    move_funcs_maps.c
+    move_funcs_order.c
+    preset.c
+    rate_state.c
+    scans.c
+    simpsim.c
+    split_cmd_line.c
+    state.c
+)
 
 IF (FCS_FREECELL_ONLY)
     LIST (REMOVE_ITEM FREECELL_SOLVER_LIB_MODULES preset.c)
@@ -245,20 +281,3 @@
 
     FIND_LIBRARY(LIBREDBLACK_LIB redblack)
 
-ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
-    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))
-
-# Search for Judy ( http://judy.sourceforge.net/ ) if appropriate.
-IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
-    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
-    (FCS_RCS_STATES AND (${FCS_RCS_CACHE_STORAGE} STREQUAL "FCS_RCS_CACHE_STORAGE_JUDY")
-    )
-)
-
-    FIND_LIBRARY(LIBJUDY_LIB Judy)
-ENDIF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_JUDY") OR
-    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_JUDY") OR
-    (FCS_RCS_STATES AND (${FCS_RCS_CACHE_STORAGE} STREQUAL "FCS_RCS_CACHE_STORAGE_JUDY")
-    )
-)
-

=== Presets/CMakeLists.txt ===
SUBDIRS( presets )

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/presetrc.proto.in
    ${CMAKE_CURRENT_BINARY_DIR}/presetrc
)

INSTALL(
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/presetrc"
    DESTINATION
        "${PKGDATADIR}"
)

=== board_gen/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/../Common.cmake" )
-
 ADD_EXECUTABLE (
     make-gnome-freecell-board
     make_gnome_freecell_board.c
@@ -33,21 +31,26 @@
 )
 
 ADD_CUSTOM_TARGET(
-    "${make_pysol}"
+    "make_pysol_board"
     ALL DEPENDS "${_dest}"
 )
 
 SET (_make_py_dest "${_dest}")
 
+# Empty list
+SET (_pod_targets )
+
 RUN_POD2MAN(
-    "${CMAKE_CURRENT_SOURCE_DIR}/fc-solve-board_gen.pod"
+    "_pod_targets"
+    "fc-solve-board_gen.pod"
     "fc-solve-board_gen.6"
     "6"
-    "board_gen"
-    "board_gen ${VERSION}"
+    "Freecell Solver"
+    "Freecell Solver ${VERSION}"
 )
 
 INSTALL_MAN("${CMAKE_CURRENT_BINARY_DIR}/fc-solve-board_gen.6" 6)
+# INSTALL_MAN("fc-solve-board_gen.6" 6)
 
 # Install the nroff symbolic links.
 INSTALL_MAN ("make-aisleriot-freecell-board.6" 6)
@@ -72,3 +75,7 @@
         "bin"
 )
 
+ADD_CUSTOM_TARGET(
+    "docs_pods" ALL
+    DEPENDS ${_pod_targets}
+)

=== t/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-INCLUDE( "${CMAKE_CURRENT_SOURCE_DIR}/../Common.cmake" )
-
 MACRO(MY_ADD_EXE EXE_FILE C_FILE)
     SET (EXE_FILE_DEST "${CMAKE_CURRENT_SOURCE_DIR}/${EXE_FILE}")
     SET (C_FILE_SRC "${CMAKE_CURRENT_SOURCE_DIR}/${C_FILE}")
@@ -13,7 +11,7 @@
 
     SET_SOURCE_FILES_PROPERTIES (
         "${C_FILE}"
-        PROPERTIES 
+        PROPERTIES
             OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../card.c"
             GENERATED "1"
     )
@@ -30,6 +28,13 @@
 IF (FCS_WITH_TEST_SUITE)
 
     FIND_LIBRARY(LIBTAP_LIB tap)
+    IF (NOT LIBTAP_LIB)
+        MESSAGE (FATAL_ERROR
+"You must install libtap ( http://www.shlomifish.org/open-source/projects/libtap/ ) and its development package or headers to run the test suite.
+If you're not interested in building it, run cmake with the -DFCS_WITH_TEST_SUITE= flag."
+    )
+    ENDIF (NOT LIBTAP_LIB)
+    MY_FIND_GMP ("to run the test suite." "FCS_WITH_TEST_SUITE")
 
     INCLUDE_DIRECTORIES (BEFORE "${CMAKE_BINARY_DIR}")
 
@@ -50,7 +55,7 @@
 
     SET_SOURCE_FILES_PROPERTIES (
         "out-split-cmd-line.c"
-        PROPERTIES 
+        PROPERTIES
             OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../split_cmd_line.c"
             GENERATED "1"
     )
@@ -68,27 +73,49 @@
 
     SET_SOURCE_FILES_PROPERTIES (
         "bit-reader-and-writer-test.c"
-        PROPERTIES 
+        PROPERTIES
             OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../bit_rw.h"
             GENERATED "1"
     )
 
-    SET (EXE_FILE "t/delta-states-test.exe")
+    IF (DEBONDT_DELTA_STATES)
 
-    ADD_EXECUTABLE(
-        "${EXE_FILE}"
-        "${CMAKE_CURRENT_SOURCE_DIR}/delta-states-test.c"
-    )
+        SET (EXE_FILE "t/delta-states-debondt-test.exe")
 
-    TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB})
+        ADD_EXECUTABLE(
+            "${EXE_FILE}"
+            "${CMAKE_CURRENT_SOURCE_DIR}/debondt-delta-states-test.c"
+        )
 
-    SET_SOURCE_FILES_PROPERTIES (
-        "delta-states-test.c"
-        PROPERTIES
-            OBJECT_DEPENDS
-                "${CMAKE_CURRENT_SOURCE_DIR}/../delta_states.c"
-            GENERATED "1"
-    )
+        TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB} ${LIBGMP_LIB})
+
+        SET_SOURCE_FILES_PROPERTIES (
+            "delta-states-test.c"
+            PROPERTIES
+                OBJECT_DEPENDS
+                    "${CMAKE_CURRENT_SOURCE_DIR}/../delta_states_debondt.c"
+                GENERATED "1"
+        )
+
+    ELSE (DEBONDT_DELTA_STATES)
+
+        SET (EXE_FILE "t/delta-states-test.exe")
+
+        ADD_EXECUTABLE(
+            "${EXE_FILE}"
+            "${CMAKE_CURRENT_SOURCE_DIR}/delta-states-test.c"
+        )
+
+        TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB} ${LIBGMP_LIB})
+
+        SET_SOURCE_FILES_PROPERTIES (
+            "delta-states-test.c"
+            PROPERTIES
+                OBJECT_DEPENDS
+                    "${CMAKE_CURRENT_SOURCE_DIR}/../delta_states.c"
+                GENERATED "1"
+        )
+    ENDIF (DEBONDT_DELTA_STATES)
 
     SET (EXE_FILE "t/dbm-kaztree-compare-records-test.exe")
 
@@ -97,7 +124,7 @@
         "dbm-kaztree-compare-records-test.c"
     )
 
-    # This is a kind-of-temporary kludge to make 
+    # This is a kind-of-temporary kludge to make
     # "dbm-kaztree-compare-records-test.c" build.
     ADD_DEFINITIONS("-DFCS_DBM_USE_LIBAVL=1"
         "-I${CMAKE_CURRENT_SOURCE_DIR}/.."

=== Presets/presets/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 INSTALL(
     FILES
         "abra-kadabra.sh"
+        "amateur-star.sh"
         "blue-yonder.sh"
         "children-playing-ball.sh"
         "cool-jives.sh"
@@ -12,6 +13,9 @@
         "hello-world.sh"
         "john_galt_line-500.sh"
         "maliciously-obscure.sh"
+        "micro-finance.sh"
+        "micro-finance-improved.sh"
+        "qualified-seed.sh"
         "rin-tin-tin.sh"
         "sand-stone.sh"
         "sentient-pearls.sh"

=== debian/changelog ===
freecell-solver (3.20.0-1ubuntu1) saucy; urgency=low

  * Add quotes around CMake arguments so parameters aren't orphaned when
    passed; Fixes FTBFS
    - update debian/rules 

 -- Micah Gersten <micahg@ubuntu.com>  Sun, 07 Jul 2013 00:27:32 -0500

freecell-solver (3.20.0-1) unstable; urgency=low

  * Imported Upstream version 3.20.0
  * Added shebang to the new presets
  * Standards-version and dh_compat update
  * Pass on `dpkg-buildflags --get LDFLAGS' for hardening

 -- Gergely Risko <risko@debian.org>  Thu, 27 Jun 2013 13:37:12 +0200

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,15 @@
 Source: freecell-solver
 Section: devel
 Priority: optional
-Maintainer: Gergely Risko <risko@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Gergely Risko <risko@debian.org>
 Vcs-Browser: http://git.debian.org/?p=collab-maint/freecell-solver.git;a=summary
 Vcs-Git: git://git.debian.org/collab-maint/freecell-solver.git
-Build-depends: cmake (>= 2.6), dpkg-dev (>= 1.16.1~), cdbs (>= 0.4.85~),
+Build-depends: debhelper (>= 7), cmake (>= 2.6), cdbs,
  debhelper (>= 9~),
  dh-buildinfo
 Homepage: http://fc-solve.berlios.de/
-Standards-Version: 3.9.3.1
+Standards-Version: 3.9.4
 
 Package: libfreecell-solver0
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,11 +1,12 @@
 #!/usr/bin/make -f
 
 DEB_AUTO_UPDATE_DEBIAN_CONTROL := true
-DEB_CMAKE_EXTRA_FLAGS := -DDATADIR=/usr/share
+DEB_CMAKE_EXTRA_FLAGS := -DDATADIR=/usr/share -DFCS_WITH_TEST_SUITE= \
+                         -DCMAKE_EXE_LINKER_FLAGS="$(shell dpkg-buildflags --get LDFLAGS)" \
+                         -DCMAKE_MODULE_LINKER_FLAGS="$(shell dpkg-buildflags --get LDFLAGS)" \
+                         -DCMAKE_SHARED_LINKER_FLAGS="$(shell dpkg-buildflags --get LDFLAGS)"
 DEB_CLEAN_EXCLUDE := config.h.orig
 
-DPKG_EXPORT_BUILDFLAGS = 1
-include /usr/share/dpkg/buildflags.mk
 include /usr/share/cdbs/1/class/cmake.mk
 include /usr/share/cdbs/1/rules/debhelper.mk

=== debian/watch ===
version=2
http://fc-solve.berlios.de/download.html http://download.berlios.de/fc-solve/freecell-solver-([\d\.]*).tar.gz

## freecell-solver 3.26.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -4,7 +4,9 @@
 
 SHLOMIF_COMMON_SETUP("${private_mod_path}")
 
-SET (PKGDATADIR "${DATADIR}/freecell-solver")
+SET (PKGDATADIR_SUBDIR "freecell-solver")
+SET (RELATIVE_PKGDATADIR "${RELATIVE_DATADIR}/${PKGDATADIR_SUBDIR}")
+SET (PKGDATADIR "${DATADIR}/${PKGDATADIR_SUBDIR}")
 
 # Introduces VERSION , CPACK_PACKAGE_VERSION_MAJOR,
 # CPACK_PACKAGE_VERSION_MAJOR, and CPACK_PACKAGE_VERSION_PATCH
@@ -69,7 +71,7 @@
     SET(CPACK_NSIS_HELP_LINK "http:\\\\\\\\fc-solve.shlomifish.org")
     SET(CPACK_NSIS_URL_INFO_ABOUT "http:\\\\\\\\fc-solve.shlomifish.org")
     SET(CPACK_NSIS_DISPLAY_NAME "Freecell Solver")
-    SET(CPACK_NSIS_CONTACT "shlomif@iglu.org.il")
+    SET(CPACK_NSIS_CONTACT "shlomif@shlomifish.org")
     SET(CPACK_NSIS_MODIFY_PATH ON)
     # Setting for NSIS :
     SET(CPACK_NSIS_MUI_ICON "${CMAKE_CURRENT_SOURCE_DIR}\\\\fc-solve.ico")
@@ -277,7 +279,3 @@
 
 # Search for libredblack if appropriate.
 IF ((${FCS_STATE_STORAGE} STREQUAL "FCS_STATE_STORAGE_LIBREDBLACK_TREE") OR
-    (${FCS_STACK_STORAGE} STREQUAL "FCS_STACK_STORAGE_LIBREDBLACK_TREE"))
-
-    FIND_LIBRARY(LIBREDBLACK_LIB redblack)
-

=== Presets/CMakeLists.txt ===
SUBDIRS( presets )

SET (suf "/presets/")
SET (PRESETS_DATA_DIR "${PKGDATADIR}${suf}")
IF (WIN32 AND NOT UNIX)
    # We need to put an actual $ followed by { and EXE_DIRNAME so we
    # escape it.
    SET (PRESETS_DATA_DIR "\${EXE_DIRNAME}/../${RELATIVE_PKGDATADIR}${suf}")
ENDIF (WIN32 AND NOT UNIX)

CONFIGURE_FILE(
    ${CMAKE_CURRENT_SOURCE_DIR}/presetrc.proto.in
    ${CMAKE_CURRENT_BINARY_DIR}/presetrc
)

INSTALL(
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/presetrc"
    DESTINATION
        "${RELATIVE_PKGDATADIR}"
)

=== board_gen/CMakeLists.txt ===
--- 
+++ 
@@ -6,11 +6,6 @@
 ADD_EXECUTABLE(
     make-aisleriot-freecell-board
     make_aisleriot_freecell_board.c
-)
-
-ADD_EXECUTABLE(
-    make-microsoft-freecell-board
-    make_microsoft_freecell_board.c
 )
 
 ADD_EXECUTABLE(
@@ -49,21 +44,22 @@
     "Freecell Solver ${VERSION}"
 )
 
-INSTALL_MAN("${CMAKE_CURRENT_BINARY_DIR}/fc-solve-board_gen.6" 6)
-# INSTALL_MAN("fc-solve-board_gen.6" 6)
+IF (UNIX)
+    INSTALL_MAN("${CMAKE_CURRENT_BINARY_DIR}/fc-solve-board_gen.6" 6)
+    # INSTALL_MAN("fc-solve-board_gen.6" 6)
 
-# Install the nroff symbolic links.
-INSTALL_MAN ("make-aisleriot-freecell-board.6" 6)
-INSTALL_MAN ("make-gnome-freecell-board.6" 6)
-INSTALL_MAN ("make_pysol_freecell_board.py.6" 6)
-INSTALL_MAN ("pi-make-microsoft-freecell-board.6" 6)
+    # Install the nroff symbolic links.
+    INSTALL_MAN ("make-aisleriot-freecell-board.6" 6)
+    INSTALL_MAN ("make-gnome-freecell-board.6" 6)
+    INSTALL_MAN ("make_pysol_freecell_board.py.6" 6)
+    INSTALL_MAN ("pi-make-microsoft-freecell-board.6" 6)
+ENDIF (UNIX)
 
 INSTALL(
     TARGETS
         "make-gnome-freecell-board"
         "pi-make-microsoft-freecell-board"
         "make-aisleriot-freecell-board"
-        "make-microsoft-freecell-board"
     DESTINATION
         "bin"
 )

=== t/CMakeLists.txt ===
--- 
+++ 
@@ -39,12 +39,12 @@
     INCLUDE_DIRECTORIES (BEFORE "${CMAKE_BINARY_DIR}")
 
     MY_ADD_EXE (
-        "t/card-test-render.exe"
+        "card-test-render.t.exe"
         "card-test-render.c"
     )
 
     MY_ADD_EXE (
-        "t/card-test-parse.exe"
+        "card-test-parse.t.exe"
         "card-test-parse.c"
     )
 
@@ -62,7 +62,7 @@
 
     FILE (MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/t")
 
-    SET (EXE_FILE "t/bit-reader-and-writer-test.exe")
+    SET (EXE_FILE "bit-reader-and-writer-test.t.exe")
 
     ADD_EXECUTABLE(
         "${EXE_FILE}"
@@ -80,7 +80,7 @@
 
     IF (DEBONDT_DELTA_STATES)
 
-        SET (EXE_FILE "t/delta-states-debondt-test.exe")
+        SET (EXE_FILE "delta-states-debondt-test.t.exe")
 
         ADD_EXECUTABLE(
             "${EXE_FILE}"
@@ -99,7 +99,7 @@
 
     ELSE (DEBONDT_DELTA_STATES)
 
-        SET (EXE_FILE "t/delta-states-test.exe")
+        SET (EXE_FILE "delta-states-test.t.exe")
 
         ADD_EXECUTABLE(
             "${EXE_FILE}"
@@ -117,7 +117,7 @@
         )
     ENDIF (DEBONDT_DELTA_STATES)
 
-    SET (EXE_FILE "t/dbm-kaztree-compare-records-test.exe")
+    SET (EXE_FILE "dbm-kaztree-compare-records-test.t.exe")
 
     ADD_EXECUTABLE(
         "${EXE_FILE}"
@@ -132,5 +132,19 @@
         )
     TARGET_LINK_LIBRARIES (${EXE_FILE} ${LIBTAP_LIB})
 
+    SET (perl_script "${PROJECT_SOURCE_DIR}/scripts/generate-individual-valgrind-test-scripts.pl")
+    SET (valg_out  "${CMAKE_CURRENT_BINARY_DIR}/t/valgrind--range_parallel_solve__11982_opt.t")
+
+    ADD_CUSTOM_COMMAND(
+        OUTPUT "${valg_out}"
+        COMMAND "perl" "${perl_script}"
+        MAIN_DEPENDENCY "${perl_script}"
+        DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/t/lib/FC_Solve/Test/Valgrind.pm"
+    )
+
+    ADD_CUSTOM_TARGET(
+        generate_valgrind_tests ALL
+        DEPENDS "${valg_out}"
+    )
 ENDIF(FCS_WITH_TEST_SUITE)

=== Presets/presets/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,8 @@
         "the-iglu-cabal.sh"
         "three-eighty.sh"
         "toons-for-twenty-somethings.sh"
+        "video-editing.sh"
         "yellow-brick-road.sh"
     DESTINATION
-        "${PKGDATADIR}/presets"
+        "${RELATIVE_PKGDATADIR}/presets"
 )

=== debian/changelog ===
freecell-solver (3.26.0-1) unstable; urgency=low

  * Imported Upstream version 3.26.0
    (closes: #715914, #716097, #716171, #716286)
  * Proper quoting in debian/rules (closes: #715224)
  * Added shebang to the new video-editing.sh preset
  * Renamed AUTHORS, README, TODO, USAGE and NEWS to end with .txt
  
 -- Gergely Risko <risko@debian.org>  Fri, 13 Jun 2014 16:27:45 +0200

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,14 @@
 Source: freecell-solver
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Gergely Risko <risko@debian.org>
+Maintainer: Gergely Risko <risko@debian.org>
 Vcs-Browser: http://git.debian.org/?p=collab-maint/freecell-solver.git;a=summary
 Vcs-Git: git://git.debian.org/collab-maint/freecell-solver.git
 Build-depends: debhelper (>= 7), cmake (>= 2.6), cdbs,
  debhelper (>= 9~),
  dh-buildinfo
 Homepage: http://fc-solve.berlios.de/
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 
 Package: libfreecell-solver0
 Architecture: any
